=== debian/changelog ===
groonga (16.0.0+dfsg-1) unstable; urgency=medium

  * New upstream version 16.0.0+dfsg

 -- Kentaro Hayashi <kenhys@xdump.org>  Mon, 09 Feb 2026 19:11:39 +0900
